<template>
  <div class="w-3/5 mx-auto text-center mt-40">
    <h1 class="text-3xl lilita">Comment pouvons-nous vous aider ?</h1>
    <p class="mt-20 w-3/4 mx-auto">Nous sommes là pour vous aider à cultiver votre passion pour les  plantes! Que vous ayez des questions, des suggestions ou simplement  envie de partager votre amour pour le monde végétal, n'hésitez pas à  nous contacter. Notre équipe dévouée est toujours ravie d'échanger avec  vous et de vous accompagner dans votre parcours botanique. Remplissez le  formulaire ci-dessous ou envoyez-nous un e-mail à contact@arosaje.fr .  Nous avons hâte de vous entendre!</p>
  </div>
  <div class="ma-none mt-20 w-full h-screen lightmode flex" :class="{'div-color': darkmode }">
    <div class="my-auto w-full">
        <div class="w-3/5 mx-auto">
          <div class="flex justify-between w-3/4 mx-auto">
            <div class="w-2/5 " :class="{'text-white': darkmode}">
              <label for="nom" class="block text-lg font-bold ">Nom*</label>
              <input type="text" v-model="nom" id="nom" name="nom" class="mt-1 px-4 py-2 w-full border-gray-300 rounded-md focus:ring-indigo-500 focus:border-indigo-500">
            </div>
            <div class="w-2/5">
              <label for="prenom" class="block text-lg font-bold ">Prénom*</label>
              <input type="text" v-model="prenom" id="prenom" name="prenom" class="mt-1 px-4 py-2 w-full border-gray-300 rounded-md focus:ring-indigo-500 focus:border-indigo-500">
            </div>
          </div>
          <div class="flex justify-between w-3/4 mx-auto mt-10">
            <div class="w-2/5">
              <label for="email" class="block text-lg font-bold ">Email*</label>
              <input for="email" type="email" required  @blur="validateEmail" v-model="email" id="email" name="email" class="mt-1 px-4 py-2 w-full border-gray-300 rounded-md focus:ring-indigo-500 focus:border-indigo-500">
              <p v-if="!emailValid" style="color: red;">Email non conforme</p>
            </div>
            <div class="w-2/5">
              <label for="telephone" class="block text-lg font-bold ">Téléphone</label>
              <input type="tel" v-model="telephone" id="telephone" name="telephone" class="mt-1 px-4 py-2 w-full border-gray-300 rounded-md focus:ring-indigo-500 focus:border-indigo-500">
            </div>
          </div>
          <div class="mb-4 w-3/4 mx-auto mt-10">
            <label for="message" class="block text-lg font-bold ">Votre message*</label>
            <textarea id="message" v-model="message" name="message" rows="4" class="mt-1 px-4 py-2 w-full border-gray-300 rounded-md focus:ring-indigo-500 focus:border-indigo-500"></textarea>
          </div>
          <div class="mb-4 w-3/4 mx-auto ">
            <input type="checkbox" v-model="checkbox" id="newsletter" name="newsletter" class="ml-2 rounded-md text-indigo-600 focus:ring-indigo-500 focus:border-indigo-500">
            <label for="newsletter" class="ml-2 text-lg font-medium ">En soumettant ce formulaire, j'accepte les conditions générales d'utilisation de l'application .</label>
          </div>
          <div class="mb-4 w-3/4 mx-auto mt-10">
            <button type="submit" class="px-4 py-2 bg-indigo-500 text-white rounded-md hover:bg-indigo-600" @click="sendEmail()">Envoyer</button>
          </div>
        </div>
    </div>
  </div>
</template>

<script lang="ts">
import { ref, watch } from 'vue';
import { useDarkModeStore } from '~/stores/myStore';
import { storeToRefs } from 'pinia';
import axios from 'axios';

export default {
  setup() {
    const store = useDarkModeStore();
    const { getIsDarkMode } = storeToRefs(store);

    const darkmode = ref(getIsDarkMode.value);

    watch(getIsDarkMode, newValue => {
      darkmode.value = newValue;
    });

    return { darkmode };
  },
  data() {
    return {
      nom: '',
      prenom: '',
      email: '',
      telephone: '',
      message: '',
      emailValid: true,
      checkbox: false
    };
  },
  methods: {
      async sendEmail() {
        if(this.checkbox === true && this.nom !== '' && this.prenom !== '' && (this.email !== '' || this.telephone !== '' )&& this.message !== '' && this.emailValid === true) {
          try {  
            const form = new FormData();
            form.append("firstname", this.nom);
            form.append("lastname", this.prenom);
            form.append("email", this.email);
            form.append("phone", this.telephone);
            form.append("description", this.message);
            const options = {
              method: 'POST',
              url: 'https://api.arosaje.fr/api/contact',
              headers: {
                'Content-Type': 'multipart/form-data'
              },
              data: form
            };
            axios.request(options)
          }
          catch (error) {
            console.error(error);
          }
        } else {
          console.log('Veuillez remplir tous les champs');
        } 
      },
      validateEmail() {
        if(this.email !== '') {
          const email = this.email;
          const regex = /^[a-zA-Z0-9._-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,6}$/;
          if(!regex.test(email)) {
            console.log('Email invalide');
            this.emailValid = false;
          }else {
            console.log('Email valide');
            this.emailValid = true;
          }
        }
      }
    }
}
</script>
<style>
.div-color {
  background-color: #111 !important;
  color: white !important;
}

.lightmode {
  background-color: #DFDFDF;
}
</style>

